import unittest
from unittest.mock import patch

from tmc import points
from tmc.utils import load, load_module, reload_module, get_stdout, check_source
from functools import reduce
import os
import textwrap
from random import randint

exercise = 'src.items_multiplied_by_two'
function = 'double_items'


@points('1.double_items')
class DoubleItemsTest(unittest.TestCase):
    @classmethod
    def setUpClass(cls):
        with patch('builtins.input', side_effect=[AssertionError("Att be om input från användaren förväntades inte")]):
           cls.module = load_module(exercise, 'en')
    
    def test_0_main_program_ok(self):
        ok, line = check_source(self.module)
        message =  """Koden för att testa funktionerna ska placeras inuti
if __name__ == "__main__":
block. Följande rad ska flyttas:
"""
        self.assertTrue(ok, message+line)

    def test_1_function_exists(self):
        try:
            from src.items_multiplied_by_two import double_items
        except:
            self.assertTrue(False, 'Din kod bör innehålla en funktion som heter double_items(numbers: list)' )
        try:
            from src.items_multiplied_by_two import double_items
            double_items([1])
        except:
            self.assertTrue(False, 'Se till att den funktionen kan anropas som\ndouble_items([1])' )

    def test_2_type_of_return_value(self):
        double_items = load(exercise, function, 'en')
        val = double_items([1])
        self.assertTrue(type(val) == list, f"Funktionen {function} returnerar inget listovärde med när double_items([1]) anropas.")
    
    def test_3_lists(self):
        test_cases = ([1,3,5,7], [2,6,4,8,2,6,4], [9,7,5,3,1], [10,100,1000,100,10], [9,9,9,9,9])
        for test_case in test_cases:
            with patch('builtins.input', side_effect=[AssertionError("Att be om input från användaren förväntades inte")]):
                reload_module(self.module)
                output_at_start = get_stdout()
                double_items = load(exercise, function, 'en')
                
                correct = [x*2 for x in test_case]
                test_case2 = test_case[:]

                try:
                    test_result = double_items(test_case)
                except:
                    self.assertTrue(False, f"Se till att den funktionen fungerar med input\n{test_case2}")

                self.assertEqual(correct, test_result, f"Resultatet på\n{test_result} \nmatchar inte med modelllösningen\n{correct}\nnär input är\n{test_case2}")
                self.assertEqual(test_case, test_case2, f"Funktionen bör inte ändra den ursprungliga listan. Värdet ska vara {test_case2} men det är {test_case}.")
              
if __name__ == '__main__':
    unittest.main()